Index: imaps-frontend/src/components/AppContext/AppContext.jsx
===================================================================
--- imaps-frontend/src/components/AppContext/AppContext.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/AppContext/AppContext.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,31 @@
+import React, {createContext, useState, useContext, useEffect} from 'react';
+import {verifyToken} from "../../scripts/util/verifyToken.js";
+
+const AppContext = createContext();
+export const AppProvider = ({ children }) => {
+    const [isAuthenticated, setIsAuthenticated] = useState(false);
+    const [username, setUsername] = useState('');
+    const [loading, setLoading] = useState(true);
+
+    useEffect(() => {
+        verifyToken(setIsAuthenticated,setUsername,setLoading)
+    }, []);
+
+
+    return (
+        <AppContext.Provider
+            value={{
+                isAuthenticated,
+                username,
+                loading,
+                setIsAuthenticated,
+                setUsername,
+                setLoading,
+            }}
+        >
+            {children}
+        </AppContext.Provider>
+    );
+};
+
+export const useAppContext = () => useContext(AppContext);
Index: imaps-frontend/src/components/DeleteConfirmationModal/DeleteConfirmationModal.jsx
===================================================================
--- imaps-frontend/src/components/DeleteConfirmationModal/DeleteConfirmationModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/DeleteConfirmationModal/DeleteConfirmationModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,26 @@
+import styles from "./DeleteConfirmationModal.module.css";
+
+export default function DeleteConfirmationModal({ isOpen, onClose, onDelete, maps }) {
+  if (!isOpen) return null;
+
+  return (
+    <div className={styles.modalOverlay}>
+      <div className={styles.modalContent}>
+        <h2>Select a Map to Delete</h2>
+        <ul className={styles.mapList}>
+          {maps.map((map) => (
+            <li key={map.mapName} className={styles.mapItem}>
+              {map.mapName}
+              <button onClick={() => onDelete(map.mapName)} className={styles.deleteButton}>
+                Delete
+              </button>
+            </li>
+          ))}
+        </ul>
+        <div className={styles.modalActions}>
+          <button onClick={onClose}>Cancel</button>
+        </div>
+      </div>
+    </div>
+  );
+}
Index: imaps-frontend/src/components/FilterBar/FilterBar.jsx
===================================================================
--- imaps-frontend/src/components/FilterBar/FilterBar.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/FilterBar/FilterBar.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,32 +1,34 @@
-import React from "react";
+import React, { useState, useEffect, useCallback } from "react";
 import styles from "./FilterBar.module.css";
 
-function FilterBar() {
-  const filterLocation = (category) => {
-    console.log(`Filter locations by: ${category}`);
-    // filtering logic
-  };
+export default function FilterBar({roomTypes,map}) {
+  const [selectedCategory, setSelectedCategory] = useState("all");
+
+
+
+  const filterLocation = useCallback((category) => {
+    map.setFilter(category)
+    setSelectedCategory(category);
+  },[])
 
   return (
     <div className={styles.wrapper}>
       <div className={styles.scrollableContainer}>
-        <button className={styles.buttonValue} onClick={() => filterLocation("all")}>
+        <button
+          className={`${styles.buttonValue} ${selectedCategory === "all" ? styles.active : ""}`}
+          onClick={() => filterLocation("all")}
+        >
           All
         </button>
-        <button className={styles.buttonValue} onClick={() => filterLocation("Classrooms")}>
-          Classrooms
-        </button>
-        <button className={styles.buttonValue} onClick={() => filterLocation("Administrative")}>
-          Administrative
-        </button>
-        <button className={styles.buttonValue} onClick={() => filterLocation("Labs")}>
-          Labs
-        </button>
-        <button className={styles.buttonValue} onClick={() => filterLocation("Restrooms")}>
-          Restrooms
-        </button>
-        <button className={styles.buttonValue} onClick={() => filterLocation("Cafeteria")}>
-          Cafeteria
-        </button>
+
+        {roomTypes?.map((roomType, index) => (
+          <button
+            key={index}
+            className={`${styles.buttonValue} ${selectedCategory === roomType.name ? styles.active : ""}`}
+            onClick={() => filterLocation(roomType.name)}
+          >
+            {roomType.name}
+          </button>
+        ))}
       </div>
     </div>
@@ -34,3 +36,2 @@
 }
 
-export default FilterBar;
Index: imaps-frontend/src/components/LoadingContainer/LoadingContainer.jsx
===================================================================
--- imaps-frontend/src/components/LoadingContainer/LoadingContainer.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/LoadingContainer/LoadingContainer.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,10 @@
+import React from "react";
+
+export const LoadingContainer = () => {
+    return (
+        <div className="loading-container">
+            <div className="spinner"></div>
+            <p>Loading, please wait...</p>
+        </div>
+    );
+}
Index: imaps-frontend/src/components/Logo/Logo.jsx
===================================================================
--- imaps-frontend/src/components/Logo/Logo.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Logo/Logo.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,23 @@
+import React from "react";
+import { useNavigate } from "react-router-dom";
+import logoImage from "../../assets/logo_icon.png";
+import styles from "./Logo.module.css";
+
+function Logo({ position = "fixed" }) {
+  const navigate = useNavigate();
+
+  const handleClick = () => {
+    navigate("/");
+  };
+
+  return (
+    <div
+      className={position === "fixed" ? styles.fixedLogoContainer : styles.inlineLogoContainer}
+      onClick={handleClick}
+    >
+      <img src={logoImage} alt="Logo" className={styles.logoImage} />
+    </div>
+  );
+}
+
+export default Logo;
Index: imaps-frontend/src/components/MapControls/MapControls.jsx
===================================================================
--- imaps-frontend/src/components/MapControls/MapControls.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/MapControls/MapControls.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -1,10 +1,14 @@
-import React, { useState } from "react";
+import React, {useEffect, useState} from "react";
 import styles from "./MapControls.module.css";
 import plusIcon from "../../assets/plus_icon.png";
 import minusIcon from "../../assets/minus_icon.png";
 import floorIcon from "../../assets/floor_icon.png";
+import HttpService from "../../scripts/net/HttpService.js";
 
-export default function MapControls({ onZoomIn, onZoomOut, onFloorChange }) {
-  const [currentFloor, setCurrentFloor] = useState(1); // Starting floor
+export default function MapControls({onFloorChange,mapName }) {
+  const [currentFloor, setCurrentFloor] = useState(0);
+  const [floors, setFloors] = useState([]);
+
+  // Starting floor
 
   // Handle floor selection
@@ -20,8 +24,8 @@
       {/* Zoom Controls */}
       <div className={styles.zoomControls}>
-        <button onClick={onZoomIn} className={styles.zoomButton}>
+        <button className={styles.zoomButton}>
           <img src={plusIcon} alt="Zoom In" />
         </button>
-        <button onClick={onZoomOut} className={styles.zoomButton}>
+        <button className={styles.zoomButton}>
           <img src={minusIcon} alt="Zoom Out" />
         </button>
@@ -29,17 +33,23 @@
 
       {/* Floor Selector */}
-      <div className={styles.floorSelector}>
-        <img src={floorIcon} alt="Floor Icon" className={styles.floorIcon} />
-        <select
-          value={currentFloor}
-          onChange={(e) => handleFloorChange(parseInt(e.target.value, 10))}
-          className={styles.floorDropdown}
-        >
-          <option value={1}>1F</option>
-          <option value={2}>2F</option>
-          <option value={3}>3F</option>
-          <option value={4}>4F</option>
-        </select>
-      </div>
+      {/*<div className={styles.floorSelector}>*/}
+      {/*  <img src={floorIcon} alt="Floor Icon" className={styles.floorIcon} />*/}
+      {/*  <select*/}
+      {/*    value={currentFloor}*/}
+      {/*    onChange={(e) => handleFloorChange(parseInt(e.target.value, 10))}*/}
+      {/*    className={styles.floorDropdown}*/}
+      {/*  >*/}
+      {/*    {floors?.map(floor => (*/}
+      {/*        <option key={floor.floorNumber} value={floor.floorNumber}>*/}
+      {/*          {floor.floorNumber}F*/}
+      {/*        </option>*/}
+
+      {/*    ))}*/}
+      {/*    /!*<option value={1}>1F</option>*!/*/}
+      {/*    /!*<option value={2}>2F</option>*!/*/}
+      {/*    /!*<option value={3}>3F</option>*!/*/}
+      {/*    /!*<option value={4}>4F</option>*!/*/}
+      {/*  </select>*/}
+      {/*</div>*/}
     </div>
   );
Index: imaps-frontend/src/components/MapInfoModal/MapInfoModal.jsx
===================================================================
--- imaps-frontend/src/components/MapInfoModal/MapInfoModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/MapInfoModal/MapInfoModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,170 @@
+import React, {useEffect, useState} from "react";
+import styles from "./MapInfoModal.module.css";
+import {json, useNavigate} from "react-router-dom";
+import edit_icon from "../../assets/edit_icon_black.png";
+import PublishForm from "../PublishForm/PublishForm.jsx";
+import HttpService from "../../scripts/net/HttpService.js";
+import config from "../../scripts/net/netconfig.js";
+import {useAppContext} from "../AppContext/AppContext.jsx";
+
+export default function MapInfoModal({isOpen, onClose, map, onDelete, onUpdate, onPublish, published=false}) {
+    const [isEditPopupOpen, setEditPopupOpen] = useState(false);
+    const [editedName, setEditedName] = useState(map?.mapName || "");
+    const [editedGmapsUrl, setEditedGmapsUrl] = useState(map?.gmaps_url || "");
+    const [publishFormOpen,setPublishFormOpen] = useState(false)
+    const navigate = useNavigate();
+    const[loadedFormData,setLoadedFormData] = useState(null)
+
+
+    useEffect(() => {
+        console.log("GMAPS: " + JSON.stringify(map))
+    }, []);
+
+    const {username} = useAppContext();
+
+    if (!isOpen || !map) return null;
+
+    const handleView = () => {
+        navigate(`/myMaps/${map.mapName}/View`)
+    };
+
+    const handleEdit = () => {
+        navigate(`/myMaps/${map.mapName}/Draw`)
+    };
+
+    const handleDelete = () => {
+        if (window.confirm(`Are you sure you want to delete the map "${map.mapName}"?`)) {
+            onDelete(map.mapName);
+            onClose();
+        }
+    };
+
+
+    const openEditPopup = () => {
+        setEditPopupOpen(true);
+    };
+
+    const closeEditPopup = () => {
+        setEditPopupOpen(false);
+    };
+
+    const handleEditSubmit = async () => {
+        const updatedMap = {
+            ...map,
+            mapName: editedName,
+            gmaps_url: editedGmapsUrl,
+        };
+
+        try {
+            //await onUpdate(updatedMap);
+            setEditPopupOpen(false);
+        } catch (error) {
+            console.error("Error updating map:", error);
+        }
+    };
+
+    const openPublishModal = async () => {
+        const httpService = new HttpService(true);
+        const respForm = await httpService.get(`${config.my_maps.publish_get}?mapName=${map.mapName}`)
+        setLoadedFormData(respForm);
+        setPublishFormOpen(true)
+    };
+
+    const sendPublishRequest = async (formData) => {
+        const httpService = new HttpService(true);
+        formData.mapName = map.mapName;
+        console.log("FORMDATA: "+JSON.stringify(formData))
+        await httpService.post(`${config.my_maps.publish}?username=${username}`,formData);
+        setPublishFormOpen(false)
+        onPublish()
+    }
+
+    return (
+        <div className={styles.modalOverlay} onClick={onClose}>
+            <div className={styles.modalContent} onClick={(e) => e.stopPropagation()}>
+                {publishFormOpen && (
+                    <PublishForm mapName={map.mapName} formData={loadedFormData} onSubmit={sendPublishRequest} onCancel={() => setPublishFormOpen(false)}/>
+                )}
+
+                <img src={map.image_url} alt="Map Thumbnail" className={styles.mapImage}/>
+                <h2 className={styles.title}>
+                    {map.mapName}
+                    <img
+                        src={edit_icon}
+                        alt="Edit"
+                        className={styles.editIcon}
+                        onClick={openEditPopup}
+                    />
+                </h2>
+                <p><strong>Status:</strong> {map.status}</p>
+
+                <p><strong>Created At:</strong> {new Date(map.created_at).toLocaleString()}</p>
+                <p><strong>Modified At:</strong> {new Date(map.modified_at).toLocaleString()}</p>
+                <p><strong>Published
+                    At:</strong> {map.published_at ? new Date(map.published_at).toLocaleString() : "Not published yet"}
+                </p>
+                <p>
+                    <strong>Google Maps URL:</strong>
+                    <a href={map.gMapsUrl}  rel="noopener noreferrer">
+                        Open in Google Maps
+                    </a>
+                </p>
+
+                <div className={styles.buttonContainer}>
+                    <button className={styles.viewButton} onClick={handleView}>
+                        View
+                    </button>
+                    <button className={styles.editButton} onClick={handleEdit}>
+                        Edit
+                    </button>
+                    <button className={styles.deleteButton} onClick={handleDelete}>
+                        Delete
+                    </button>
+                    {!map.is_published && !published && (
+                        <button className={styles.publishButton} onClick={openPublishModal}>
+                            Publish
+                        </button>
+                    )}
+                </div>
+                <button className={styles.closeButton} onClick={onClose}>
+                    Close
+                </button>
+
+                {isEditPopupOpen && (
+                    <div className={styles.editPopupOverlay} onClick={closeEditPopup}>
+                        <div
+                            className={styles.editPopupContent}
+                            onClick={(e) => e.stopPropagation()}
+                        >
+                            <h3 className={styles.title}>Edit Map Details</h3>
+                            <div className={styles.editField}>
+                                <label>Map Name:</label>
+                                <input
+                                    type="text"
+                                    value={editedName}
+                                    onChange={(e) => setEditedName(e.target.value)}
+                                />
+                            </div>
+                            <div className={styles.editField}>
+                                <label>Google Maps URL:</label>
+                                <input
+                                    type="text"
+                                    value={editedGmapsUrl}
+                                    onChange={(e) => setEditedGmapsUrl(e.target.value)}
+                                />
+                            </div>
+                            <div className={styles.editPopupButtons}>
+                                <button className={styles.submitButton} onClick={handleEditSubmit}>
+                                    Submit
+                                </button>
+                                <button className={styles.cancelButton} onClick={closeEditPopup}>
+                                    Cancel
+                                </button>
+                            </div>
+                        </div>
+                    </div>
+                )}
+            </div>
+        </div>
+    );
+}
Index: imaps-frontend/src/components/Modals/Components/Modal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/Modal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/Modal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,86 @@
+import React, { useRef, useState, useEffect } from "react";
+import styles from "../EntranceModal/EntranceModal.module.css";
+
+export default function Modal({ children, title, isOpen, toggleModal }) {
+  const modalRef = useRef(null);
+  const [dragging, setDragging] = useState(false);
+  const [position, setPosition] = useState({ x: "50%", y: "50%" });
+  const [offset, setOffset] = useState({ x: 0, y: 0 });
+
+  const handleMouseDown = (e) => {
+    if (!modalRef.current) return;
+    setDragging(true);
+    const rect = modalRef.current.getBoundingClientRect();
+    setOffset({
+      x: e.clientX - rect.left,
+      y: e.clientY - rect.top,
+    });
+  };
+
+  const handleMouseMove = (e) => {
+    if (!dragging) return;
+    setPosition({
+      x: e.clientX - offset.x,
+      y: e.clientY - offset.y,
+    });
+  };
+
+  const handleMouseUp = () => {
+    setDragging(false);
+  };
+
+  useEffect(() => {
+    if (dragging) {
+      window.addEventListener("mousemove", handleMouseMove);
+      window.addEventListener("mouseup", handleMouseUp);
+    } else {
+      window.removeEventListener("mousemove", handleMouseMove);
+      window.removeEventListener("mouseup", handleMouseUp);
+    }
+    return () => {
+      window.removeEventListener("mousemove", handleMouseMove);
+      window.removeEventListener("mouseup", handleMouseUp);
+    };
+  }, [dragging]);
+
+  if (isOpen) {
+    document.body.classList.add(styles.activeModal);
+  } else {
+    document.body.classList.remove(styles.activeModal);
+  }
+
+  return (
+      <>
+        {isOpen && (
+            <div className={styles.modal}>
+              <div onClick={toggleModal} className={styles.overlay}></div>
+              <div
+                  ref={modalRef}
+                  className={styles.modalContent}
+                  style={{
+                    top: typeof position.y === "string" ? position.y : `${position.y}px`,
+                    left: typeof position.x === "string" ? position.x : `${position.x}px`,
+                    transform:
+                        typeof position.x === "string" && typeof position.y === "string"
+                            ? "translate(-50%, -50%)"
+                            : "none",
+                  }}
+              >
+                <div
+                    className={styles.draggableHeader}
+                    onMouseDown={handleMouseDown}
+                >
+                  <h2 className={styles.title}>{title}</h2>
+                </div>
+                <form className={styles.form}>
+                  {children}
+                  <button className={styles.closeModal} onClick={toggleModal}>
+                    CLOSE
+                  </button>
+                </form>
+              </div>
+            </div>
+        )}
+      </>
+  );
+}
Index: imaps-frontend/src/components/Modals/Components/ModalAddRoomTypes.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalAddRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalAddRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,25 @@
+import styles from "../RoomTypeModal/RoomTypeModal.module.css";
+import React from "react";
+
+export default function ModalAddRoomTypes(handleInputChange,formData,addRoomType){
+    return (
+        <>
+            <h2>Manage Room Types</h2>
+            <div className={styles.formGroup}>
+                <label htmlFor="type">Add New Room Type:</label>
+                <input
+                    type="text"
+                    id="type"
+                    name="type"
+                    value={formData.type}
+                    onChange={handleInputChange}
+                    placeholder="Enter a new room type (e.g., Office, Classroom)"
+                />
+                <button type="button" className={styles.addButton} onClick={addRoomType}>
+                    Add Type
+                </button>
+            </div>
+        </>
+
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalDescriptionField.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalDescriptionField.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalDescriptionField.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,16 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+
+export default function ModalDescriptionField({shapeInfo,updateModalData}){
+    return (
+        <div className={styles.formGroup}>
+            <label htmlFor="description">Description:</label>
+            <textarea
+                id="description"
+                name="description"
+                value={shapeInfo.description}
+                onChange={updateModalData}
+                rows="3"
+            />
+        </div>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalDisplayConnections.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalDisplayConnections.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalDisplayConnections.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,30 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+import React, {useEffect} from "react";
+
+export default function ModalDisplayConnections({connections,removePinFromList}){
+
+    useEffect(() => {
+        console.log("CONNNECTIONS: " + connections);
+    }, []);
+
+    return (
+        <>
+            <h3>Connections:</h3>
+            <ul className={styles.pinList}>
+                {connections.length > 0 ? (
+                    connections.map((pin, index) => (
+                        <li key={index} className={styles.pinItem}>
+                            {pin}
+                            <button onClick={() => removePinFromList(pin)} className={styles.removeButton}>
+                                Remove
+                            </button>
+                        </li>
+                    ))
+                ) : (
+                    <li>No connections added</li>
+                )}
+            </ul>
+            <br/>
+        </>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalDisplayRoomTypes.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalDisplayRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalDisplayRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,24 @@
+import styles from "../RoomTypeModal/RoomTypeModal.module.css";
+import React from "react";
+
+export default function ModalDisplayRoomTypes(roomTypes,removeRoomType){
+    return (
+        <>
+            <h3>Available Room Types:</h3>
+            <ul className={styles.roomTypeList}>
+                {roomTypes.length > 0 ? (
+                    roomTypes.map((type, index) => (
+                        <li key={index} className={styles.roomTypeItem}>
+                            {type}
+                            <button className={styles.removeButton} onClick={() => removeRoomType(type)}>
+                                Remove
+                            </button>
+                        </li>
+                    ))
+                ) : (
+                    <li>No room types available</li>
+                )}
+            </ul>
+        </>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalMainEntranceCheckbox.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalMainEntranceCheckbox.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalMainEntranceCheckbox.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,16 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+
+export default function ModalMainEntranceCheckbox ({shapeInfo,updateModalData}){
+    return (
+        <div className={styles.formGroupCheckbox}>
+            <input
+                type="checkbox"
+                id="isMainEntrance"
+                name="isMainEntrance"
+                checked={shapeInfo.isMainEntrance}
+                onChange={updateModalData}
+            />
+            <label htmlFor="isMainEntrance" style={{color: "white"}}>Main Entrance</label>
+        </div>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalNameField.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalNameField.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalNameField.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,19 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+import React from "react";
+
+export default function ModalNameField({shapeInfo,updateModalData,phtext}) {
+    return (
+        <div className={styles.formGroup}>
+            <label htmlFor="name">Name:</label>
+            <input
+                type="text"
+                id="name"
+                name="name"
+                value={shapeInfo.name}
+                onChange={updateModalData}
+                placeholder={phtext}
+                required
+            />
+        </div>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalRoomTypes.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalRoomTypes.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,20 @@
+import styles from "../RoomModal/RoomModal.module.css";
+import React from "react";
+
+export default function ModalRoomTypes({shapeInfo,updateModalData,roomTypes}){
+    console.log("ROOM TYPES: " + roomTypes)
+
+    return (
+        <div className={styles.formGroup}>
+            <label htmlFor="type">Type:</label>
+            <select id="type" name="type" onChange={updateModalData} value={shapeInfo.type} required>
+                <option value="">Select Room Type</option>
+                {roomTypes?.map((roomType, index) => (
+                    <option key={index} value={roomType.name}>
+                        {roomType.name}
+                    </option>
+                ))}
+            </select>
+        </div>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalSaveButton.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalSaveButton.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalSaveButton.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,17 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+import React from "react";
+
+export default function ModalSaveButton({saveDetails}){
+    return (
+        <div className={styles.formGroup}>
+            <button
+                type="button"
+                id="submit-details"
+                onClick={saveDetails}
+                className={styles.submitButton}
+            >
+                Save
+            </button>
+        </div>
+    )
+}
Index: imaps-frontend/src/components/Modals/Components/ModalSelectConnections.jsx
===================================================================
--- imaps-frontend/src/components/Modals/Components/ModalSelectConnections.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/Components/ModalSelectConnections.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
@@ -0,0 +1,33 @@
+import styles from "../EntranceModal/EntranceModal.module.css";
+import React from "react";
+
+export default function ModalSelectConnections({shape = null,availableShapes,updateModalData,addPinToList,}) {
+
+    return shape && (
+        <div className={styles.formGroup}>
+                <label htmlFor="selectedPin">Select connections:</label>
+                <select
+                    id="selectedPin"
+                    name="selectedPin"
+                    value={shape.info.selectedPin}
+                    onChange={updateModalData}
+                    required
+                >
+                    <option value="">Select Connection</option>
+                    {availableShapes.filter ((conn) =>
+                                shape.info.selectedPins.includes(conn.name) === false &&
+                                conn.name !== "" &&
+                                conn.name !== shape.info.name
+                        )
+                        .map((conn, index) => (
+                            <option key={index} value={conn.info.name}>
+                                {conn.info.name}
+                            </option>
+                        ))}
+                </select>
+                <button type="button" onClick={addPinToList} className={styles.addButton}>
+                    Add Connection
+                </button>
+            </div>
+    )
+}
